function AdaptiveCharacterRecognition(cmd,arg1,arg2,arg3)

global pos M Mt t api netn alphabet targets flag TErr FontDisplay tim



me = 'AdaptiveCharacterRecognition';

% DEFAULTS
% nargin- Number of function arguments
if nargin == 0, cmd = ''; else cmd = lower(cmd); end

% FIND WINDOW IF IT EXISTS(    )
fig = nndfgflg(me);
if length(get(fig,'children')) == 0, fig = 0; end %    
%   .

% GET WINDOW DATA IF IT EXISTS
if fig
  H = get(fig,'userdata');
  hWndL = H(1);
end
  
  
  
  
if strcmp(cmd,'')
  if fig
    figure(fig)
    set(fig,'visible','on')
  else
    feval(me,'init') % Evaluate function
  end
  
% Close the window.
% ME() or ME('')
elseif strcmp(cmd,'close') & (fig)
  delete(fig)
  
elseif strcmp(cmd,'init') & (~fig)
% 

fig = nndemof2(me); %   

set(fig, ...
    'windowbuttondownfcn',nncallbk(me,'down'), ...%   
    'windowButtonupfcn',nncallbk(me,'up'), ...
    'BackingStore','off',...% Offscreen pixel buffer.This increases the speed with which the screen is redrawn.
    'nextplot','add'); % hold  on

 labelList='A|B|C|D|E|F|G|H|I|J|K|L|M|N|O|P|Q|R|S|T|U|V|W|X|Y|Z|a|b|c|d|e|f|g|h|i|j|k|l|m|n|o|p|q|r|s|t|u|v|w|x|y|z';
  cmdList=str2mat( ...
        ' 1 ',' 2 ','3','4','5','6','7','8','9','10',...
        '11','12','13','14','15','16','17','18','19','20','21',...
        '22','23','24','25','26','27','28','29','30','31','32','33','34',...
        '35','36','37','38','39','40','41','42','43','44','45','46','47',...
        '48','49','50','51','52');
  hWndL= uicontrol(...% 
    'Style','popup', ...
    'units','points',...
    'position',[560 450 60 20],...
    'string',labelList,...
    'UserData',cmdList);

uicontrol(...
    'units','points',...
    'position',[560 470 60 20],...
    'string','Adapt',...
    'callback',[me '(''adapt'')'])

flag=0;

load FontSampleTest
ChFin=double(ch);
ChIn=zeros(256,26);

ChFinP=ch(:,[1+26+26:26+26+26]);

load FontSample
ChIn=zeros(256,26);

ChFin=ChFin(:,[1:26 1+26+26:26+26+26]);

ChFin=cat(2,ChFin,ChFinP);

for i=1:size(ChFin,2)
   I=imresize(reshape(ChFin(:,i),40,[]),[16 16],'bilinear');
   I = im2bw(I,.15);
   ChIn(:,i)=reshape(I,256,[]);
   %imshow(I)
   camzoom(6) 
%pause(.3);
 % drawnow 
end

P=ChIn;

[alphabet,targets] = prprob;


load FontSampleAdaptFinal20

targets= eye(52);

% result font

load LearningSetFile
FontDisplay=double(LearningSet(:,1:52));

targets=[targets targets targets targets targets targets targets targets targets]; 


[R,Q] = size(alphabet);
[S2,Q] = size(targets);

load ('-mat','NetFontAdaptFinal20.m' )% network

%-----------------

M=zeros(16,'single');
Mt=zeros(16,'single');


subplot(2,2,3), imshow(Mt);

text(1,1,'Input in net character', ...
  'color',nngreen, ...
  'fontname','times', ...
  'fontsize',16, ...
  'fontangle','italic', ...
 'fontweight','bold');

subplot(2,2,4), imshow(reshape(alphabet(:,1),16,[]));

text(1,1,'Recognition character', ...
  'color',nngreen, ...
  'fontname','times', ...
  'fontsize',16, ...
  'fontangle','italic', ...
 'fontweight','bold');

subplot(2,2,1:2), t = imshow(M);
text(3,1,'Input window', ...
  'color',nngreen, ...
  'fontname','times', ...
  'fontsize',16, ...
  'fontangle','italic', ...
 'fontweight','bold');

text(1,10,'Vsoft', ...
  'color',nndkblue, ...
  'fontname','times', ...
  'fontsize',70, ...
  'fontangle','italic');

tf=get(0,'CurrentFigure');
f3 = @(varargin) setPos(varargin);
iptaddcallback(tf, 'WindowButtonDownFcn', f3);


Pz=[];

h = impoint(gca,6,4);
api = iptgetapi(h);


id =api.addNewPositionCallback(@(p) getPos(p) );
id =api.addNewPositionCallback(@(p) network(p) );
fcn = makeConstrainToRectFcn('impoint',get(gca,'XLim'),get(gca,'YLim'));
api.setDragConstraintFcn(fcn);


H = [hWndL];
 set(fig,'userdata',H)

%------------------
nnchkfs; %  
end



%------------------------

if strcmp(cmd,'down') & (fig) & (nargin == 1) %     
   tic;
   
end

if strcmp(cmd,'up') & (fig) & (nargin == 1) %     
   tim= toc;
   
end
%----------------------------
%==================================================================
% Adapt network.
%
% ME('train')
%==================================================================
if strcmp(cmd,'adapt') & (fig)
    
 Character =get(hWndL,'Value'); %     
 
 alphabetAssoziative=alphabet ;
   alphabetAssoziative(:,Character)=double(reshape(Mt,256,[]));
   noisyJErr=num2cell([alphabetAssoziative],1);
 
   if flag==0
   TErr=num2cell([targets],1);
   end
   
   netn.adaptFcn='traingdx';
   
   netn.adaptParam.lr =maxlinlr(alphabetAssoziative,'bias'); % adaptive network
   netn.trainParam.lr=0.01;
   netn.adaptParam.goal=0.1;
   netn.adaptParam.epochs=2000;
   netn.adaptParam.mc = 0.95; 
   netn.adaptParam.min_grad=1e-10;
 
  [netn,y,e] = adapt(netn,noisyJErr,TErr);
   %A2 = sim(netn,noisyJ);
A2 = compet(y{Character});
answer = find(compet(A2) == 1);
   if (Character==int8(answer))
    % mri2(:,:,:,er(c))=reshape(alphabet(:,answer),16,[]); 
   disp('-----------')
  % mse(e)  
  % c
    %er(:)
     disp('-----------')
   %  break
   if size (alphabet,2)<=52*8
   alphabet=cat(2,alphabet ,alphabetAssoziative(:,1:52)); % add alphabet in learning set 
   TErr=num2cell([  cell2mat(TErr) targets(:,1:52)],1);

   end

if size (alphabet,2)>52+52
    k = randint(1,1,[1,(size (alphabet,2))]);
end   
    
    if size (alphabet,2)<=52+52
   
   alphabet(:,Character)=double(reshape(M,256,[])); % save current character   
   
   
   elseif (size(alphabet,2)>52+52 && k>52+52) && (size(alphabet,2)<=52+52+52 && k<=52+52+52 ) 
    alphabet(:,52+52+Character)=double(reshape(M,256,[])); % save current character   
   elseif (size(alphabet,2)>52+52+52 && k>52+52+52) && (size(alphabet,2)<=52+52+52+52 && k<=52+52+52+52 ) 
    alphabet(:,52+52+52+Character)=double(reshape(M,256,[])); % save current character  
    
    elseif (size(alphabet,2)>52+52+52+52 && k>52+52+52+52) && (size(alphabet,2)<=52+52+52+52+52 && k<=52+52+52+52 ) 
    alphabet(:,52+52+52+52+Character)=double(reshape(M,256,[])); % save current character   
    
    elseif (size(alphabet,2)>52+52+52+52+52 && k>52+52+52+52+52) && (size(alphabet,2)<=52+52+52+52+52+52 && k<=52+52+52+52+52+52 ) 
    alphabet(:,52+52+52+52+52+Character)=double(reshape(M,256,[])); % save current character
    
     elseif (size(alphabet,2)>52+52+52+52+52+52 && k>52+52+52+52+52+52) && (size(alphabet,2)<=52+52+52+52+52+52+52 && k<=52+52+52+52+52+52+52 ) 
    alphabet(:,52+52+52+52+52+52+Character)=double(reshape(M,256,[])); % save current character
    
     elseif (size(alphabet,2)>52+52+52+52+52+52+52 && k>52+52+52+52+52+52+52) && (size(alphabet,2)<=52+52+52+52+52+52+52+52 && k<=52+52+52+52+52+52+52+52 ) 
    alphabet(:,52+52+52+52+52+52+52+Character)=double(reshape(M,256,[])); % save current characterv
    
    elseif (size(alphabet,2)>52+52+52+52+52+52+52+52 && k>52+52+52+52+52+52+52+52) && (size(alphabet,2)<=52+52+52+52+52+52+52+52+52 && k<=52+52+52+52+52+52+52+52+52 ) 
    alphabet(:,52+52+52+52+52+52+52+52+Character)=double(reshape(M,256,[])); % save current characterv
    
    
   end
   
   flag=1;
   network
   end
   mse(e)
   
   save('FontSampleAdaptFinal21','alphabet')
   save('NetFontAdaptFinal21.m','netn');
   
 
end;




function network(pp)
global  M Mt  netn alphabet FontDisplay;

noisyJ = reshape(double(Mt),1,[])';

A2 = sim(netn,noisyJ);
A2 = compet(A2);
answer = find(compet(A2) == 1);
%subplot(2,1,1),imshow(I)
%camzoom(7.8)
 
subplot(2,2,4),imshow(reshape(FontDisplay(:,answer),40,[]));
 text(2,2,'Recognition character', ...
  'color',nngreen, ...
  'fontname','times', ...
  'fontsize',16, ...
  'fontangle','italic', ...
 'fontweight','bold');
 subplot(2,2,3),imshow(Mt);
text(1,1,'Input in net character', ...
  'color',nngreen, ...
  'fontname','times', ...
  'fontsize',16, ...
  'fontangle','italic', ...
 'fontweight','bold');  

%% !
%  ,       .
%     . .
% 1)      -   
%       .
% 2)      ,   .
%      ,    
%    ,    
%  .
 
%%
function y = nncallbk(demo,command)
%NNCALLBK Neural Network Design utility function.

% NNCALLBK(DEMO,COMMAND)
%   DEMO - Name of demo.
%   COMMAND - Command.
% Returns string of form: DEMO('COMMAND').


y = sprintf('%s(''%s'')',demo,command);


%%     
function nnchkfs

Always_Small = 0;
c = computer;
pos = get(gcf,'position');
if strcmp(c(1:2),'PC') | strcmp(c(1:3),'MAC')
  if (pos(3) < 500 | pos(4) < 400) | Always_Small
    nnshrink
  end
end
set(gcf,'visible','on');

%%  
function fig = nndemof2(s1,s2,s3,s4,s5)


fig = nnbg(s1,[0 0 500 400]);


set(fig,'nextplot','add')% = hold on
H = get(fig,'userdata');
h1 = H(1);

% SAVE HANDLES AND LOCK FIGURE

set(fig,'userdata',[h1])
set(fig,'color',nndkgray,'color',nnltgray)
set(fig,'nextplot','new')
%hidegui

%%
function fig = nnbg(n,r)

% NEW FIG
fig = figure('visible','off');

% make this backwards compatible (doublebuffer was new in MATLAB 5.2)
try
    set(fig,'DoubleBuffer','on')
    set(fig, 'Renderer', 'openGL');
catch
end

% GET SCREEN SIZE
su = get(0,'units');
set(0,'units','points');
ss = get(0,'ScreenSize');
set(0,'units',su);
left = ss(1);
bottom = ss(2);
width = ss(3);
height = ss(4);

% CENTER FIGURE ON SCREEN
fig_x = 650;
fig_y = 500;
pos = [(width-fig_x)/2+left, (height-fig_y)/2+bottom, fig_x fig_y];

% MAKE SURE TOP LEFT CORNER IS ON SCREEN
% IF SCREEN IS TOO SMALL FOR WINDOW.
if (width < fig_x)
  pos(1) = 5;
end
if (height < fig_y)
  pos(2) = bottom+height-fig_y-40;
end

% CREATE THE FIGURE
if nargin == 0
  n = '';
end
set(fig,...
  'units','points',...
  'position',pos,...
  'resize','off', ...
  'color',nnltgray, ...
  'inverthardcopy','off', ...
  'nextplot','add',...
  'name',n,...
  'numbertitle','off');

% FIGURE AXIS
fig_axis = axes(...
  'visible','off',...
  'units','points', ...
  'position',[0 0 fig_x fig_y],...
  'xlim',[0 fig_x],'ylim',[0 fig_y],...
  'nextplot','add');

% SAVE HANDLES AND LOCK FIGURE
set(fig,...
  'userdata',[fig_axis],...
  'handlevisibility','callback')
hidegui(fig)



%%   

function f=nndfgflg(n)

%   N - Name of figure (string).
% Returns handle to figure with name N if it exists.
% Returns 0, otherwise.



%==================================================================

z = get(0,'children');
for i=1:length(z)
  typ = get(z(i),'type');
  if strcmp(typ,'figure')
    nam = get(z(i),'name');
  if strcmp(nam,n)
    f = z(i);
    return
  end
  end
end

f = 0;

%% 

function c = nnltgray
c = [0.68 0.68 0.68];

function c = nnblack
c = [0 0 0];

function c = nndkblue
c = [0 0 0.3];

function c = nndkgray
c = [0.4 0.4 0.4];

function c = nngreen
c = [0 0.7 0];

function c = nnred
c = [1 0.1 0.1];

function c = nnltyell
c = [1 1 0.6]*0.95;



